<template>
  <div class="btn-group btn-group-actions btn-group-xs">
    <a
      v-b-tooltip.hover.top="{ variant: 'dark' }"
      class="btn btn-link link-secondary btn-icon"
      :class="hideActionClass('switch')"
      title="Switch between possibles values"
      @click="switchEnumParam"
    >
      <SwitchHorizontalIcon class="icon-xxs" />
    </a>
    <a
      v-b-tooltip.hover.top="{ variant: 'dark' }"
      class="btn btn-link link-secondary btn-icon text-blue disabled"
      :class="hideActionClass('clear')"
      title="Reset to default"
      @click="resetParam"
    >
      <RefreshIcon class="icon-xxs" />
    </a>
    <a
      v-b-tooltip.hover.top="{ variant: 'dark' }"
      class="btn btn-link link-secondary btn-icon text-blue disabled"
      :class="hideActionClass('reset')"
      title="Clear value"
      @click="clearParam"
    >
      <ClearFormattingIcon class="icon-xxs" />
    </a>
    <a
      v-if="ruleProperties?.description"
      v-b-tooltip.hover.top="{ variant: 'dark' }"
      class="btn btn-link link-secondary btn-icon text-green cursor-default"
      :title="ruleProperties?.description || ''"
    >
      <InfoCircleIcon class="icon-xxs" />
    </a>
    <a href="#" class="btn btn-link link-secondary btn-icon disabled">
      <DotsVerticalIcon class="icon-xxs" />
    </a>
  </div>
</template>

<script>
import queryFactoryConstants from './constants/queryFactory';

export default {
  props: {
    ruleProperties: {
      type: Object,
      default: () => {},
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    updateValue: {
      type: Function,
      default: () => ({}),
    },
  },
  computed: {},
  methods: {
    hideActionClass(action) {
      const type = this?.ruleProperties?.type;
      const disabledClass = 'invisible disabled';
      return !type ||
        !queryFactoryConstants.inputTypes[type].withActions.includes(action)
        ? disabledClass
        : '';
    },
    switchEnumParam() {
      // eslint-disable-next-line no-useless-return
      if (this.disabled) return;
    },
    resetParam() {
      // eslint-disable-next-line no-useless-return
      if (this.disabled) return;
    },
    clearParam() {
      // eslint-disable-next-line no-useless-return
      if (this.disabled) return;
      // this.updateValue(this.parameter.key, newValue);
    },
  },
};
</script>
